!       
!    .
!   -    
!   //  .
!
! MouseLeft    -    (+/-)
! MouseLeft2   -     ""
! EnterKey   -     ""
! InsertKey -     ""
! DeleteKey   -     ""
!
  PROGRAM

  Include('Keycodes.clw')
  Include('TplEqu.clw')

  Include('dLib.inc')

  MAP
    UpDateForm
  END

MainQue              TDynaQueueClass   !   

!       
!    .
!      LoadDeclare()    .
DeclareFName         STRING(FILE:MaxFilePath),STATIC
DeclareFile          FILE,DRIVER('ASCII'),PRE(TXT),NAME(DeclareFName)
Record                 RECORD
Line                     STRING(255)
                       END
                     END
DeclaresList         QUEUE             !   
Name                   STRING(100)
                     END
DeclareName          STRING(100)       !   
ListFormat           STRING(1024)      !    
HeaderText           STRING(255)       !     

C2P                  EQUATE(5)         !   -   

LastSortCol          LONG(0)           !    
NewSortCol           LONG              !     
SortField            LONG(0)           !     

GlobalRequest        LONG              !  
GlobalResponse       LONG              !  

Var                  ANY

MainWin WINDOW('The dynamic list'),AT(,,278,200),FONT('MS Sans Serif',8,,),CENTER,IMM,SYSTEM,GRAY, |
         MAX,RESIZE,AUTO
       GROUP,AT(0,0,164,40),USE(?Group:Header),BOXED
         PROMPT('Declaration file:'),AT(4,10),USE(?Prompt:DeclareFName)
         ENTRY(@s60),AT(60,10,100,10),USE(DeclareFName),SKIP,LEFT,TIP('The file of declaration of structures of the list'), |
             INS,READONLY
         PROMPT('Structure:'),AT(4,24),USE(?Prompt:DeclareName)
         LIST,AT(60,24,100,10),USE(?DeclareName),VSCROLL,MSG('Change list structure'),TIP('Change list structure'), |
             DROP(5),FROM(DeclaresList)
       END
       GROUP,AT(166,0,112,40),USE(?Group:Buttons),BOXED
         BUTTON('Insert'),AT(170,8,50,12),USE(?Insert),MSG('Insert new record to queue'),TIP('Insert new record to queue')
         BUTTON('Delete'),AT(170,24,50,12),USE(?Delete),MSG('Delete record from queue'),TIP('Delete record from queue')
         BUTTON('Change'),AT(224,8,50,28),USE(?Change),MSG('Change record'),TIP('Change record')
       END
       LIST,AT(0,44),USE(?MainList),FULL,HVSCROLL,ALRT(EnterKey),ALRT(InsertKey),ALRT(DeleteKey),ALRT(MouseLeft2),ALRT(MouseLeft),FROM('')
     END

  Code

  MainQue.ShowError = True             !    
  do Setup
  Open(MainWin)
  MainWin{PROP:MinWidth} = 278
  MainWin{PROP:MinHeight} = 100
  do RefreshWindow
  Accept
    Case Field()
    of ?DeclareName
       if Event() = EVENT:Accepted
          Item# = Choice(?DeclareName)
          Get(DeclaresList,Item#)
          if ErrorCode() then Clear(DeclareName) else
             DeclareName = DeclaresList.Name
          .
          do BuildNewList
          do RefreshWindow
       .
    of ?Insert
       if Event() = EVENT:Accepted
          GlobalRequest = InsertRecord
          do CallUpDate
       .
    of ?Delete
       if Event() = EVENT:Accepted
          GlobalRequest = DeleteRecord
          do CallUpDate
       .
    of ?Change
       if Event() = EVENT:Accepted
          GlobalRequest = ChangeRecord
          do CallUpDate
       .
    of ?MainList
       Case Event()
       of EVENT:PreAlertKey
          Cycle
       of EVENT:AlertKey
          Case KeyCode()
          of MouseLeft
             if ?MainList{PROPLIST:MouseDownRow} = 0
                NewSortCol = ?MainList{PROPLIST:MouseDownField}
                if NewSortCol <> LastSortCol
                   SortField = ?MainList{PROPLIST:FieldNo,NewSortCol}
                   if LastSortCol
                      HeaderText = ?MainList{PROPLIST:Header,LastSortCol}
                      HeaderText = Sub(HeaderText,4,Size(HeaderText))
                      ?MainList{PROPLIST:Header,LastSortCol} = Clip(HeaderText)
                   .
                   HeaderText = ?MainList{PROPLIST:Header,NewSortCol}
                   ?MainList{PROPLIST:Header,NewSortCol} = '[+]' & Clip(HeaderText)
                   LastSortCol = NewSortCol
                else                   !   
                   SortField *= -1
                   HeaderText = ?MainList{PROPLIST:Header,LastSortCol}
                   HeaderText[2] = Choose(SortField => 0,'+','-')
                   ?MainList{PROPLIST:Header,LastSortCol} = Clip(HeaderText)
                .
                !       ,
                !     SortField     
                !  : '+1,-2,+4'.     
                !  .
                if Records(MainQue.Q) then MainQue._Sort(SortField).
                Select(?MainList,1)
                do RefreshWindow
             .
          of InsertKey
             if ~?Insert{PROP:Disable} then Post(EVENT:Accepted,?Insert).
          of DeleteKey
             if ~?Delete{PROP:Disable} then Post(EVENT:Accepted,?Delete).
          of EnterKey orof MouseLeft2
             if (?MainList{PROPLIST:MouseDownRow} <> 0) AND ~?Change{PROP:Disable}
                Post(EVENT:Accepted,?Change)
  . .  .  .  .
  Close(MainWin)

  Return

Setup ROUTINE
  Free(DeclaresList)
  DeclareFName = 'T_dLib.txt'
  Open(DeclareFile)
  if ErrorCode()
     Message(Error(),': '&ErrorCode(),ICON:Hand)
     Exit
  .
  SetCursor(CURSOR:WAIT)
  Set(DeclareFile)
  Loop
    Next(DeclareFile); if ErrorCode() then Break.
    P# = InString('#QUEUE',Upper(TXT:Line),1,1)
    if ~P#
       P# = InString('#GROUP',Upper(TXT:Line),1,1)
       if ~P# then Cycle.
    .
    P# = InString('(',TXT:Line,1,P#)
    if ~P# then DeclaresList.Name = 'No name' else
       L# = InString(')',TXT:Line,1,P#)
       if ~L# then L# = Len(TXT:Line) + 1.
       DeclaresList.Name = Left(Sub(TXT:Line,(P#+1),(L#-P#-1)))
    .
    Add(DeclaresList)
  .
  SetCursor()
  Close(DeclareFile)

RefreshWindow ROUTINE
  if MainQue.Q &= Null                 !    
     Disable(?Insert,?Change)
  else
     Enable(?Insert)
     if Records(MainQue.Q)             !    
        Enable(?Delete,?Change)
     else                              !    
        Disable(?Delete,?Change)
  .  .
  Display()

BuildNewList ROUTINE
  Clear(ListFormat)
  ?MainList{PROP:From} = ''
  ?MainList{PROP:Format} = ''
  !      .
  !  ,   ,    
  !      .
  MainQue.ReInit()
  if DeclareName
     if DeclareName = 'No name'
     !       - 
        MainQue.LoadDeclare(,DeclareFName,)
     else
     !        
        MainQue.LoadDeclare(,DeclareFName,DeclareName)
     .
     !     -  
     if MainQue.ErrCode <> err:Ok then MainQue.ReInit().
  .
  if ~(MainQue.Q &= Null) AND MainQue.Fields()
     !  -      :)
     MainQue.OutDebugInfo(OUTDEBUG:ShowInText)
     ?MainList{PROP:From} = MainQue.Q            !    
     !        .
     !     .
     !      List`.
     !     Fields()  - OVER-  
     !          OVER-.
     MainQue.ListMode = True
     Col# = 0
     Loop F# = 1 to MainQue.Fields()
       if MainQue.Type(F#) = TYPE:GROUP
            OMIT('***',_C55_)
          Grp# += 1
            ***
          Cycle
       else
          ListFormat = ?MainList{PROP:Format} & '50L#' & (F#-Grp#) & '#'
          Col# += 1
          ?MainList{PROP:Format} = Clip(ListFormat)
       .
       !       
       !      ,     
       !   .    
       !        .
       !       .
       Format" = MainQue.Picture(F#,True,Align",Width#)
       ?MainList{PROPLIST:Picture,Col#} = Clip(Format")
       Case Upper(Align")
       of 'L'
          ?MainList{PROPLIST:Left,Col#} = True
          ?MainList{PROPLIST:LeftOffset,Col#} = 2
       of 'C'; ?MainList{PROPLIST:Center,Col#} = True
       of 'R'
          ?MainList{PROPLIST:Right,Col#} = True
          ?MainList{PROPLIST:RightOffset,Col#} = 2
       .
       ?MainList{PROPLIST:Resize,Col#} = True
       ?MainList{PROPLIST:RightBorder,Col#} = True
       !      ""  
       !  .
       Label" = MainQue.Label(,LABEL:ONLY)
       ?MainList{PROPLIST:Header,Col#} = Clip(Label")
       ?MainList{PROPLIST:HeaderCenter,Col#} = True
       ?MainList{PROPLIST:HeaderCenterOffset,Col#} = 0
       !   .
       if Width# > 20 then Width# = 20.
       L# = Len(Clip(Label")); if L# > Width# then Width# = L#.
       ?MainList{PROPLIST:Width,Col#} = Width# * C2P
  .  .
  Select(?MainList)
  LastSortCol = 0
  NewSortCol = 0
  SortField = 0

CallUpDate ROUTINE
  Clear(GlobalResponse)
  LocalRequest# = GlobalRequest
  if LocalRequest# = InsertRecord
     Clear(MainQue.Q)
  else
     Item# = Choice(?MainList)
     Get(MainQue.Q,Item#)
     if ErrorCode() then Exit.
  .
  if LocalRequest# = DeleteRecord
     if Message('Delete selected record?','Delete record', |
                ICON:Question,BUTTON:Yes+BUTTON:No,BUTTON:No) = BUTTON:Yes
        Delete(MainQue.Q)
        if ~ErrorCode() then GlobalResponse = RequestCompleted else
           Message(Error(),'Error delete record!',ICON:Hand)
     .  .
  else
     UpDateForm()
  .
  if GlobalResponse = RequestCompleted
     if LocalRequest# = InsertRecord
        Msg" = 'insert'
        if ~SortField then Add(MainQue.Q) else MainQue._Add(SortField).
     elsif LocalRequest# = ChangeRecord
        Msg" = 'change'
        if ~SortField then Put(MainQue.Q) else MainQue._Put(SortField).
     .
     if ErrorCode()
        Message('Error of '&Clip(Msg")&' of record!|'&Error(),ErrorCode(),ICON:Hand)
     .
     do RefreshWindow
  .
  Select(?MainList,Pointer(MainQue.Q))

!===================================================================================================

UpDateForm           PROCEDURE

!     -      
!  -      .   
!         
!   .
FormGrp              TDynaGroupClass   !    
UseTarget            ANY               !       USE-

XPos                 LONG
YPos                 LONG
DeltaY               LONG(14)
PromtW               LONG(100)
EntryH               LONG(10)
EntryW               LONG(0)
EntryMaxW            LONG(130)
FirstControl         LONG(0)
LastControl          LONG(0)

FormWin WINDOW('Form'),AT(,,240,170),FONT('MS Sans Serif',8,,),CENTER,VSCROLL,SYSTEM,GRAY,MAX,RESIZE, |
         AUTO
       GROUP,AT(2,0,110,26),USE(?Group:FormButtons),BOXED
         BUTTON('OK'),AT(6,8,50,14),USE(?Ok),DEFAULT
         BUTTON('Cancel'),AT(58,8,50,14),USE(?Cancel)
       END
     END

  Code
  FormGrp.ShowError = True             !    
  Open(FormWin)
  FormWin{PROP:MinWidth} = 120
  FormWin{PROP:MinHeight} = 40
  do Setup
  do RefreshWindow
  Accept
    Case Field()
    of ?Ok
       if Event() = EVENT:Accepted
          !      " ",
          ! .. - MainQue.Q :=: FormGrp.G
          ! ,  ,      
          !  .      .
          !  -, ,    : MainQue.Q = FormGrp.G
          !      .    
          !   FormGrp     , 
          !   .
          MainQue.DeepAssign(FormGrp)  !   : FormGrp.DeepAssign(MainQue,True)
          GlobalResponse = RequestCompleted
          Break
       .
    of ?Cancel
       if Event() = EVENT:Accepted
          GlobalResponse = RequestCancelled
          Break
  . .  .
  Destroy(FirstControl,LastControl)
  Close(FormWin)
  Return

Setup ROUTINE
  FormWin{PROP:Hide} = True            !      
  !         
  !  .  : FormGrp LIKE(MainQue)
  FormGrp._LIKE('FormGrp','FRM',MainQue)
  if (FormGrp.ErrCode <> err:Ok) OR (FormGrp.G &= Null)
     FormGrp.ReInit()                  !   
  else
     !        .
     FormGrp.DeepAssign(MainQue)       ! FormGrp :=: MainQue
     !         
     !    OVER- (   OVER-).
     XPos = ?Group:FormButtons{PROP:XPos}
     YPos = ?Group:FormButtons{PROP:YPos} + ?Group:FormButtons{PROP:Height}
     Clear(FirstControl,1)
     Loop F# = 1 to FormGrp.Fields()
       if (FormGrp.Type(F#) <> TYPE:GROUP) AND ((FormGrp.FOver(,InOver#) => 0) AND ~InOver#)
          !   
          Control# = Create(0,CREATE:PROMPT); if ~Control# then Cycle.
          LastControl = Control#
          if Control# < FirstControl then FirstControl = Control#.
          YPos += DeltaY
          Control#{PROP:XPos} = XPos; Control#{PROP:YPos} = YPos
          Label" = FormGrp.Label(,LABEL:ONLY)
          if ~Label" then Label" = 'Field N' & F#.
          Label" = Clip(Label") & ' :'
          Control#{PROP:Text} = Clip(Label")
          Control#{PROP:Hide} = False
          !    
          ! !!!
          !           ,
          !     Field()  ANY-    ,  
          !   ,     .
          !   .., , ,  : DESC &STRING,
          !     Field()     ,  
          !     DESC.    
          !      USE-,    
          !         
          !    NEW()    _New().
          !     GPF.
          !         
          !   .
          if BAND(FormGrp.Type(),TYPE:EXTREF) AND ~FormGrp.GetRef() then Cycle.
          Control# = Create(0,CREATE:ENTRY); if ~Control# then Cycle.
          LastControl = Control#
          Control#{PROP:XPos} = XPos+PromtW; Control#{PROP:YPos} = YPos
          Format" = FormGrp.Picture(,True,Align",Width#)
          EntryW = Width# * C2P; if EntryW > EntryMaxW then EntryW = EntryMaxW.
          Control#{PROP:Width} = EntryW
          Control#{PROP:Height} = EntryH
          Control#{PROP:Text} = Clip(Format")
          Case Upper(Align")
          of 'L'; Control#{PROP:Left} = True
          of 'C'; Control#{PROP:Center} = True
          of 'R'; Control#{PROP:Right} = True
          .
          Control#{PROP:Ins} = True
          !     ,     
          !  .  ,  
          !        
          ! ,     .
          !   , , ,  
          !   .
          Control#{PROP:Msg} = FormGrp.Comment()
          Control#{PROP:Tip} = Control#{PROP:Msg}
          !     ,   USE-,
          !     .
          !        
          ! USE-    ANY-  .
          !  ,     ANY-
          ! ,       Field().
          !         :
          !   FormGrp.Field()
          !   Control#{PROP:Use} = FormGrp.TmpRef.A
          !    .
          !     ,    USE-
          !      .
          !           .
          UseTarget &= FormGrp.Field()
          Control#{PROP:Use} = UseTarget
          Control#{PROP:Hide} = False
  .  . .
  FormWin{PROP:Hide} = False
  Select(?Cancel+1)

RefreshWindow ROUTINE
  Display()
