  PROGRAM                              ! Copyright by S.Jayashankar, 2007

UseMSSQL             EQUATE(1)         ! They will use MS-SQL   driver
UseODBC              EQUATE(1)         ! They will use ODBC     driver
UseTOPSPEED          EQUATE(1)         ! They will use TOPSPEED driver


  Include('Equates.clw')
  Include('dLib.inc')

  MAP
  END

GLO:Query            STRING(8096)
GLO:Driver           STRING(30)
GLO:Connection       STRING(512)
GLO:Progress         BYTE

Window WINDOW('Execute SQL Query'),AT(,,529,344),FONT('Arial',8,,FONT:bold),CENTER,IMM,SYSTEM,GRAY,MAX, |
         RESIZE,AUTO
       PROMPT('Driver'),AT(4,3),USE(?GLO:Driver:Prompt),TRN
       LIST,AT(30,3,48,10),USE(GLO:Driver),LEFT(1),FONT('Verdana',9,COLOR:Maroon,FONT:bold,CHARSET:ANSI), |
           DROP(3),FROM('|MSSQL|ODBC')
       PROMPT('Connection'),AT(92,3),USE(?GLO:Connection:Prompt),TRN
       TEXT,AT(137,3,319,26),USE(GLO:Connection),BOXED,VSCROLL,FONT('Tahoma',9,COLOR:Red,FONT:bold,CHARSET:ANSI), |
           REQ
       GROUP('Q u e r y'),AT(3,30,525,120),USE(?Group:Query),BOXED,TRN
         TEXT,AT(7,40,517,107),USE(GLO:Query),BOXED,HVSCROLL,FONT('Courier New',10,COLOR:Blue,FONT:bold,CHARSET:ANSI), |
             REQ
       END
       BUTTON('&Run'),AT(461,3,66,18),USE(?Run),LEFT,FONT('Verdana',12,COLOR:Green,FONT:bold,CHARSET:ANSI), |
           ICON('Apply.ICO'),DEFAULT
       PROGRESS,USE(GLO:Progress),SMOOTH,AT(461,23,66,8),RANGE(0,100),COLOR(,,COLOR:Blue)
       SHEET,AT(2,153,526,190),USE(?CurrentTab)
         TAB('Results'),USE(?Tab:Results)
           LIST,AT(7,170,517,168),USE(?List),HVSCROLL,TIP('Results of Query'),VCR
           BUTTON('&Export to Topspeed'),AT(445,154,82,12),USE(?Export),SKIP,FLAT,RIGHT,ICON('EXPORT.ICO')
         END
         TAB('Record Structure '),USE(?Tab:RecStruct)
           TEXT,AT(7,170,517,168),USE(?RecStruct),SKIP,BOXED,HVSCROLL,FONT('Courier New',10,,FONT:bold,CHARSET:ANSI), |
               READONLY
         END
       END
     END

dSQL                 TDynaSQLClass
dFile                TDynaFileClass
dQue                 &TDynaQueueClass

Rec                  &GROUP
A                    ANY

TPSFileName          STRING(255)

  CODE
  
  DynaLib::SetMsgLang('00000409')

  dFile::RegistryDriver(,MSSQL)
  dFile::RegistryDriver(,ODBC)
  dFile::RegistryDriver(,TOPSPEED)

  OPEN(Window)

  Window{PROP:MinWidth}  = Window{PROP:Width}
  Window{PROP:MinHeight} = Window{PROP:Height}

  ACCEPT
    IF EVENT() = EVENT:Accepted
       CASE FIELD()
       OF ?Run
!         IF ~LEN(CLIP(GLO:Driver))
!            MESSAGE('NO Driver Chosen','E R R O R',ICON:Exclamation)
!            SELECT(?GLO:Driver)
!            CYCLE
!         END
         IF ~LEN(CLIP(GLO:Connection))
            MESSAGE('NO Connect Details Entered','E R R O R',ICON:Exclamation)
            SELECT(?GLO:Connection)
            CYCLE
         END
         IF ~LEN(CLIP(GLO:Query))
            MESSAGE('NO SQL Query Statement Entered','E R R O R',ICON:Exclamation)
            SELECT(?GLO:Query)
            CYCLE
         END

         DO RunQuery

       OF ?Export
         IF RECORDS(dQue.Q)
            IF FILEDIALOG('Choose the Topspeed File', TPSFileName, 'Data Files|*.TPS|ALL Files|*.*', FILE:Save+FILE:KeepDir+FILE:LongName+FILE:AddExtension)
               DO ExportToTPS
            END
         ELSE
            MESSAGE('NO Records to Export', 'E R R O R')
         END

       END
    END
  END
  CLOSE(Window)

  DISPOSE(dQue);  dSQL.SetDestQue()

  RETURN

RunQuery         ROUTINE

  ?List{PROP:From} = '' ; ?List{PROP:Format} = ''

  DISPOSE(dQue) ; dSQL.SetDestQue()

  dSQL.ShowError = True

  IF dSQL.Connect(CLIP(GLO:Driver),CLIP(GLO:Connection)) = err:Ok

     IF dSQL.Prepare(CLIP(GLO:Query), False, True, True) = err:Ok

        dFile.Clone(dSQL,'TOPSPEED','ExpFile','EXP', fCLONE:FULL+fCLONE:OPEN)
          dFile._ATTR(FILE:CREATE)
        dFile._End

        dQue &= dSQL.NewQueue('ResultQue')

        dQue.ShowError = True

        IF ~(dQue &= NULL) AND dQue.IsCompleted()
           dSQL.SetDestQue(dQue.Q)

           dSQL.ShowProgress = True

!           dSQL.ProcessDisplaySet(False, , ?GLO:Progress)
           dSQL.ProcessDisplaySet(True, 'Retrieving Data')

           dSQL.ReSet()

           dSQL.Load()  

           ?List{PROP:Format}    = dQue.ListBoxFormat(,True,False,True)

           ?List{PROP:From}      = dQue.Q

           dQue.ShowError        = False

           ?RecStruct{PROP:Text} = dQue.OutDebugInfo(,'<13,10>')
        END
     END

     dSQL.DisConnect ()
  END

  DISPLAY(?List) ; DISPLAY(?RecStruct)

  EXIT

ExportToTPS      ROUTINE

  dFile.ErrCode = True

  IF dFile.IsCompleted()
     dFile.F{PROP:Name} = CLIP(TPSFileName)

     dFile.OutDebugInfo(OUTDEBUG:ShowInText)

!     IF NOT EXISTS(TPSFileName)
        CREATE(dFile.F)
        IF ERRORCODE()
           MESSAGE(CLIP(ERRORFILE()) & ' : ' & ERROR() & ' [' & ERRORCODE() & ']|' & 'File Error : ' & FILEERROR() & ' [' & FILEERRORCODE() & ']','E R R O R - Create')
           EXIT
        END
!     END
     OPEN(dFile.F, 12h)
     IF ERRORCODE()
        MESSAGE(CLIP(ERRORFILE()) & ' : ' & ERROR() & ' [' & ERRORCODE() & ']|' & 'File Error : ' & FILEERROR() & ' [' & FILEERRORCODE() & ']','E R R O R - Open')
        EXIT
     END

     GLO:Progress = 0 ; Recs# = RECORDS(dQue.Q)

     LOOP Rec# = 1 TO Recs#
        GET(dQue.Q, Rec#)

        GLO:Progress = (Rec# * 100) / Recs# ; DISPLAY(?GLO:Progress)

        dFile.Record.G = dQue.Q

        ADD(dFile.F)
        IF ERRORCODE()
           MESSAGE(CLIP(ERRORFILE()) & ' : ' & ERROR() & ' [' & ERRORCODE() & ']|' & 'File Error : ' & FILEERROR() & ' [' & FILEERRORCODE() & ']','E R R O R - Add')
           EXIT
        END
     END

     CLOSE(dFile.F)
  END

  EXIT
