  Program

  Include('dLib.inc')

  Map
    ViewInfo(VIEW _dView,STRING _Title)
    ViewInfo(TDynaViewClass _dView,STRING _Title)
  .

TPSFile         FILE,DRIVER('TOPSPEED'),PRE(TPS),CREATE
Name_Key          KEY(+TPS:Name,+TPS:Desc),DUP,OPT,NOCASE
Code_Key          KEY(+TPS:Code),OPT,NOCASE
Ndx_Key           KEY(+TPS:Index),OPT,NOCASE,PRIMARY
Record            RECORD
Name                STRING(30)
Desc                STRING(110)
Code                LONG
Index               LONG
                . .

TPSFile1        FILE,DRIVER('TOPSPEED'),PRE(TPS1),CREATE
Name_Key          KEY(+TPS1:Name1,+TPS1:Desc1),DUP,OPT,NOCASE
Code_Key          KEY(-TPS1:Code1),OPT,NOCASE
Ndx_Key           KEY(+TPS1:Index1),OPT,NOCASE,PRIMARY
Record            RECORD
Name1               STRING(30)
Desc1               STRING(10)
Code1               LONG
Index1              LONG
                . .

TPSFile2        FILE,DRIVER('TOPSPEED'),PRE(TPS2),CREATE
Name_Key          KEY(+TPS2:Name2,+TPS2:Desc2),DUP,OPT,NOCASE
Code_Key          KEY(-TPS2:Code2),OPT,NOCASE
Ndx_Key           KEY(+TPS2:Index2),OPT,NOCASE,PRIMARY
Record            RECORD
Name2               STRING(30)
Desc2               STRING(10)
Code2               LONG
Index2              LONG
                . .

TestView        VIEW(TPSFile),FILTER('TPS:Code > 10')
                  JOIN(TPS1:Ndx_Key,TPS:Index)
                    PROJECT(TPS1:Name1,TPS1:Desc1)
                    JOIN(TPSFile2,'TPS2:Name2 = TPS1:Name1')
                      PROJECT(TPS2:Name2)
                    END
                  END
                END

DView           TDynaViewClass

  Code

  Bind(TPS:Record)                               !     
  Bind(TPS1:Record)                              !
  Bind(TPS2:Record)                              !

  dView::AddWorkFile(TPSFile,'TPSFile')          !      

  DView.ShowError = True                         !    
  DView.AddWorkFile(TPSFile1,'TPSFile1')         !    
  DView.AddWorkFile(TPSFile2,'TPSFile2')         !  

  DView._View('dView',TPSFile)
    DView._sJoin('(TPS1:Name_Key,TPS:Name),Inner')
      DView._Project(TPS1:Name1,TPS1:Desc1)
      DView._sProject('TPS1:Code1,TPS1:Index1')
    DView._End()
  DView._End()
  ViewInfo(DView,'  View-')

  DView.LoadDeclare('dView View(TPSFile),Filter(InRange(TPS:Code,1,5))|' & |
                    'Join(TPS1:Name_Key,TPS:Name),Inner|..')
  ViewInfo(DView,'  View-')

  DView.LoadDeclare(,'T_dLib.txt',' ')
  ViewInfo(DView,'  : " "')

  DView.LoadDeclare(,'T_dLib.txt',' ')
  ViewInfo(DView,'  : " "')

  ViewInfo(TestView,' VIEW-!')

  Return

ViewInfo             PROCEDURE(VIEW _dView,STRING _Title)

LinkView             TDynaViewClass

  Code
  LinkView.ShowError = True
  if LinkView.LinkTo(_dView,'LinkView') = err:Ok
     ViewInfo(LinkView,_Title)
  .
  Return

ViewInfo             PROCEDURE(TDynaViewClass _dView,STRING _Title)

sMsg                 STRING(1024)
sTmp                 STRING(512)
sPrj                 STRING(512)
nJoin                LONG
FRef                 &FILE
KRef                 &KEY

  Code
  if _dView.ErrCode OR (_dView.View &= Null)
     Message('ErrorCode = ' & _dView.ErrCode,_Title)
  else
     !    View    OutDebugInfo()
     _dView.OutDebugInfo(OUTDEBUG:ShowInText)
!     Message(_dView.OutDebugInfo(),_Title)

     !     View   , 
     !   Clarion.
     !      VIEW: JOIN=0
     nJoin = 0; do PROJECT::Format
     sMsg = _dView.Label() & ' VIEW(' & FRef{PROP:Name} & ')'
     sTmp = _dView.View{PROP:Filter}
     if sTmp
        sMsg = Clip(sMsg) & '|FILTER(''' & Clip(sTmp) & ''')'
     .
     sTmp = _dView.View{PROP:Order}
     if sTmp
        sMsg = Clip(sMsg) & '|ORDER(''' & Clip(sTmp) & ''')'
     .
     if sPrj then sMsg = Clip(sMsg) & sPrj.
     Message(sMsg,_Title)                        ! VIEW(...

     !     JOIN    .
     !  ,     JoinType,
     !    - ""   JOIN-, 
     !       .
     Loop nJoin = 1 to _dView.Joins()
       sMsg = nJoin & ' - JOIN('
       if _dView.JoinType(nJoin) = join_ByFile   ! JOIN(File)
          FRef &= _dView.GetJoinFile(,sTmp)
          sMsg = Clip(sMsg) & FRef{PROP:Name}
          if sTmp then sMsg = Clip(sMsg) & ',''' & Clip(sTmp) & ''''.
       else                                      ! JOIN(Key)
          KRef &= _dView.GetJoinKey(,Fields#,ParentFile#)
          sMsg = Clip(sMsg) & KRef{PROP:Label}
          if Fields#                             !   
             FRef &= (ParentFile#)
             Loop F# = 1 to Fields#
               sMsg = Clip(sMsg) & ',' & FRef{PROP:Label,_dView.GetJoinKeyField(,F#)}
       .  .  .
       sMsg = Clip(sMsg) & ')'
       if _dView.GetInner(nJoin) then sMsg = Clip(sMsg) & ',INNER'.
       do PROJECT::Format; if sPrj then sMsg = Clip(sMsg) & sPrj.
       Message(sMsg,_Title)
  .  .
  Return

PROJECT::Format      Routine
  Fields# = _dView.PrjFields(nJoin,AllField#,ParentFile#)
  FRef &= (ParentFile#)
  if ~Fields# then Clear(sPrj) else
     sPrj = '|PROJECT('
     if AllField#
        sPrj = Clip(sPrj) & 'All fields'
     else
        Loop F# = 1 to Fields#
          sPrj = Clip(sPrj) & FRef{PROP:Label,_dView.GetPrjField(,F#)} & ','
        .
        if Sub(Clip(sPrj),-1,1) = ',' then sPrj = Sub(sPrj,1,Len(Clip(sPrj))-1).
     .
     sPrj = Clip(sPrj) & ')'
  .
