!      TPS/DAT/DBF.
!     TDynaFileClass.Clone  
! FILE-     .
!
!       -.
!     RTL      ListBox`.
!     ,    
!  -:
! 1.    dQue      LoadTo,
!     :
!    -     dQue.Queue('ScanQue','',dFile.F).
!    -       LIKE -.
!    -      OVER    -.
!    -   .
!    -     dFile.F      LikeTo().
!    -   ListBoxFormat     _ShowOver = True.
! 2.    dQue      , 
!        ListBox   PROP:VLBProc/PROP:VLBVal.
!         .   .
!      , ,      ListBox`.
!
  PROGRAM

UseCLARION           EQUATE(1)         !   CLARION-
UseTOPSPEED          EQUATE(1)         !   TOPSPEED-
UseCLIPPER           EQUATE(1)         !   CLIPPER-
UseDBASE3            EQUATE(1)         !   DBASE3-
UseDBASE4            EQUATE(1)         !   DBASE4-
UseFOXPRO            EQUATE(1)         !   FOXPRO-

  Include('Equates.clw')
  Include('dLib.inc')

  MAP
    GetViewFile(*STRING _FileName,*STRING _Driver,*STRING _Password),BYTE
  END

GLO:FileName         STRING(FILE:MaxFilePath)
GLO:Driver           STRING(30)
GLO:Password         STRING(512)

Window WINDOW('  TPS/DAT/DBF'),AT(,,307,162),FONT('MS Sans Serif',8,,),CENTER,IMM,SYSTEM, |
         GRAY,MAX,RESIZE,AUTO
       GROUP,AT(2,0,303,26),USE(?Group:Header),BOXED
         PANEL,AT(218,4,1,22),USE(?vSeparator),BEVEL(-1)
         BUTTON(' '),AT(222,8,80,14),USE(?View),DISABLE,TIP(' <255>  ')
         PROMPT(':'),AT(6,10),USE(?Prompt:GetFile),TRN
         BUTTON,AT(32,8,16,14),USE(?GetFile),TIP('  <255> '),ICON(ICON:Open)
         ENTRY(@s255),AT(50,10,164,10),USE(GLO:FileName),SKIP,LEFT,COLOR(COLOR:BTNFACE),TIP(' <255> '), |
             INS,READONLY
       END
       LIST,AT(0,30),USE(?List),FULL,HVSCROLL,TIP(' ')
     END

ViewWin WINDOW(' '),AT(,,310,210),FONT('MS Sans Serif',8,,),CENTER,IMM,SYSTEM,GRAY,MAX, |
         RESIZE,AUTO
       BUTTON('   '),AT(2,2,130,14),USE(?Save),TIP('    <13,10>  ')
       TEXT,AT(0,20),USE(?FileInfo),BOXED,FULL,HVSCROLL,FONT('Courier New',10,,),READONLY
     END

dFile                TDynaFileClass    !   
dQue                 &TDynaQueueClass  !     

  Code

  System{PROP:CharSet} = CHARSET:Cyrillic
  dFile::RegistryDriver(,Clarion)
  dFile::RegistryDriver(,TopSpeed)
  dFile::RegistryDriver(,Clipper)
  dFile::RegistryDriver(,DBase3)
  dFile::RegistryDriver(,DBase4)
  dFile::RegistryDriver(,FoxPro)
  dFile.ShowError = True

  Open(Window)
  Window{PROP:MinWidth} = Window{PROP:Width}
  Window{PROP:MinHeight} = Window{PROP:Height}
  Accept
    if dFile.IsCompleted() then Enable(?View) else Disable(?View).
    if Event() = EVENT:Accepted
       Case Field()
       of ?GetFile
          if GetViewFile(GLO:FileName,GLO:Driver,GLO:Password) then do BuildViewQue.
       of ?View
          do ViewFileInfo
  . .  .
  Close(Window)

  Dispose(dQue)
  Return

BuildViewQue Routine
  if dFile.Clone(GLO:FileName,GLO:Driver,GLO:Password) <> err:Ok
     Select(?GetFile)
  else
     ?List{PROP:From} = ''; ?List{PROP:Format} = ''
     Dispose(dQue)
     dQue &= dFile.LoadTo('ScanQue','')
     if (dQue &= Null) OR ~dQue.IsCompleted()
        Select(?GetFile)
     else
        ?List{PROP:Format} = dQue.ListBoxFormat(,,,True)
        if Len(Clip(?List{PROP:Format})) then ?List{PROP:From} = dQue.Q.
        Select(?List)
  .  .

ViewFileInfo Routine

  DATA
loc:FileToSave STRING(FILE:MaxFilePath),AUTO

  CODE
  if ~dFile.IsCompleted() then Exit.
  loc:FileToSave = 'fScan.txt'
  Open(ViewWin)
  ?FileInfo{PROP:Text} = dFile.OutDebugInfo(,'<13,10>')
  Accept
    if (Event() = Event:Accepted) AND (Field() = ?Save)
       if FileDialog('  ',loc:FileToSave, |
                     ' |*.TXT| |*.*',FILE:Save+FILE:KeepDir+FILE:LongName)
          dFile.OutDebugInfo(loc:FileToSave,'rewrite')
  . .  .
  Close(ViewWin)

GetViewFile          PROCEDURE(*STRING _FileName,*STRING _Driver,*STRING _Password)

loc:FileName         LIKE(GLO:FileName),AUTO
loc:Driver           LIKE(GLO:Driver),AUTO
loc:Password         LIKE(GLO:Password),AUTO
loc:KeysName         LIKE(GLO:Password),AUTO
loc:Mask             STRING(100),AUTO
loc:RetFlag          BYTE,AUTO

GetFileWin WINDOW(' <255> '),AT(,,230,80),FONT('MS Sans Serif',8,,),CENTER,IMM,SYSTEM, |
         GRAY,DOUBLE,AUTO
       GROUP,AT(2,0,226,54),USE(?Group:Params),BOXED
         PROMPT(':'),AT(6,8),USE(?Prompt:Driver),TRN
         COMBO(@s30),AT(46,8,70,10),USE(loc:Driver),LEFT,TIP(' <255> '),READONLY, |
             DROP(7,70),FROM('|CLARION|TOPSPEED|DBASE3|DBASE4|CLIPPER|FOXPRO')
         PROMPT(':'),AT(6,24),USE(?Prompt:FileName),TRN
         BUTTON,AT(46,22,16,14),USE(?FileSelect),TIP('  <255> '),ICON(ICON:Open)
         ENTRY(@s255),AT(64,24,160,10),USE(loc:FileName),SKIP,LEFT,TIP(' <255> '),INS
         GROUP,AT(2,40,226,10),USE(?Group:Password)
           PROMPT(':'),AT(6,40),USE(?Prompt:Password),TRN
           ENTRY(@s100),AT(46,40,70,10),USE(loc:Password),LEFT,TIP(' <255>  '), |
               INS
         END
         GROUP,AT(2,40,226,10),USE(?Group:Keys),HIDE
           PROMPT(':'),AT(6,40),USE(?Prompt:Keys),TRN
           BUTTON,AT(46,38,16,14),USE(?KeysSelect),TIP('  '),ICON(ICON:Open)
           ENTRY(@s255),AT(64,40,160,10),USE(loc:KeysName),SKIP,LEFT,TIP(' '),INS
         END
       END
       BUTTON(''),AT(24,60,70,16),USE(?Ok),LEFT,ICON(ICON:Zoom),DEFAULT
       BUTTON('&'),AT(136,60,70,16),USE(?Cancel),LEFT,ICON(ICON:NoPrint),STD(STD:Close)
     END

  Code

  loc:FileName = _FileName
  if ~Len(Clip(_Driver)) then loc:Driver = '' else loc:Driver = _Driver.
  loc:Password = _Password
  loc:KeysName = ''
  loc:RetFlag = False

  Open(GetFileWin)
  Accept
    if Choice(?loc:Driver) <= 3
       ?Group:Password{PROP:Hide} = False
       ?Group:Keys{PROP:Hide} = True
    else
       ?Group:Password{PROP:Hide} = True
       ?Group:Keys{PROP:Hide} = False
    .
    if Event() = EVENT:Accepted
       Case Field()
       of ?FileSelect                                      ! Auto
          if Choice(?loc:Driver) = 1
             loc:Mask = 'DAT-|*.DAT|TPS-|*.TPS|DBF-|*.DBF| |*.*'
          elsif Choice(?loc:Driver) = 2                    ! DAT
             loc:Mask = 'DAT-|*.DAT| |*.*'
          elsif Choice(?loc:Driver) = 3                    ! TPS
             loc:Mask = 'TPS-|*.TPS| |*.*'
          else                                             ! DBF
             loc:Mask = 'DBF-|*.DBF| |*.*'
          .
          if FileDialog('  ',loc:FileName,loc:Mask,FILE:KeepDir+FILE:LongName)
             Select(?loc:Password)
          .
       of ?KeysSelect
          if Choice(?loc:Driver) = 4                       ! DBASE3
             loc:Mask = 'NDX-|*.NDX| |*.*'
          elsif Choice(?loc:Driver) = 5                    ! DBASE4
             loc:Mask = 'NDX/MDX-|*.NDX;*.MDX| |*.*'
          elsif Choice(?loc:Driver) = 6                    ! CLIPPER
             loc:Mask = 'NTX-|*.NTX| |*.*'
          elsif Choice(?loc:Driver) = 7                    ! FOXPRO
             loc:Mask = 'IDX/CDX-|*.IDX;*.CDX| |*.*'
          .
          Clear(loc:KeysName)
          if FileDialog(' ',loc:KeysName,loc:Mask,FILE:KeepDir+FILE:LongName+FILE:Multi)
             Select(?Ok)
          .
       of ?Ok
          if ~Len(Clip(loc:FileName))
             Message('   ','!',ICON:Exclamation)
             Select(?FileSelect)
          else
             _FileName = loc:FileName
             _Password = loc:Password
             if Choice(?loc:Driver) = 1
                Clear(_Driver)
             else
                _Driver = loc:Driver
                if Choice(?loc:Driver) > 3
                   _Password = ''
                   First# = True; Out# = 1
                   Loop P# = 1 to Len(Clip(loc:KeysName))
                     if loc:KeysName[P#] = '|'
                        if First#
                           _Password[Out#] = '/'; Out# += 1
                           First# = False
                        .
                        _Password[Out#] = '/'
                     else
                        _Password[Out#] = loc:KeysName[P#]
                     .
                     Out# += 1
             .  .  .
             loc:RetFlag = True
             Break
          .
  . .  .
  Close(GetFileWin)

  Return(loc:RetFlag)
