
  OMIT('_EndOfEquates_',_DynaLibEquates_)
!-------------------------------------------------------------------------------
! Common error codes
!-------------------------------------------------------------------------------
err:Ok               EQUATE(0)         ! No errors
err:NoInit           EQUATE(-1)        ! The copy of the class is not initialized
err:NoInGroup        EQUATE(-2)        ! The description of structure is not initiated
err:InvalidParam     EQUATE(-3)        ! Error in parameters of call of a method
err:NoFields         EQUATE(-4)        ! There are no declared fields
err:FieldNotFound    EQUATE(-5)        ! The field is not found in the current group
err:InvalidDeclare   EQUATE(-6)        ! Incorrect description of structure
err:OverNoInGroup    EQUATE(-7)        ! Overlapped field outside group
err:BadData          EQUATE(-8)        ! Error of data access
err:ConstructError   EQUATE(-9)        ! Error at creation of object
err:NoCreated        EQUATE(-10)       ! The object yet is not created
err:DeclareError     EQUATE(-11)       ! Logic error of description of structure
err:LikeNotFound     EQUATE(-12)       ! The typical LIKE-structure is not found
err:UnsupportedType  EQUATE(-13)       ! Unsupported data type
err:InitError        EQUATE(-14)       ! Error at initialization of a copy of the class
err:LinkError        EQUATE(-15)       ! Error of link to address structure
err:OverSizeError    EQUATE(-16)       ! Size of OVER-variable is less than size of structure
err:InternalError    EQUATE(-100)      ! Internal error of the library
err:WinAPI           EQUATE(2000)      ! WinAPI error = Self.ErrCode - err:WinAPI

!-------------------------------------------------------------------------------
! Types fields of structure
!-------------------------------------------------------------------------------
                     ITEMIZE,PRE(TYPE)
BYTE                   EQUATE(01h)     ! 01
SHORT                  EQUATE          ! 02
USHORT                 EQUATE          ! 03
DATE                   EQUATE          ! 04
TIME                   EQUATE          ! 05
LONG                   EQUATE          ! 06
ULONG                  EQUATE          ! 07
SREAL                  EQUATE          ! 08
REAL                   EQUATE          ! 09
DECIMAL                EQUATE          ! 0A
PDECIMAL               EQUATE          ! 0B
BFLOAT4                EQUATE(0Dh)     ! 0D
BFLOAT8                EQUATE          ! 0E
ANY                    EQUATE          ! 0F
STRING                 EQUATE(12h)     ! 12
CSTRING                EQUATE          ! 13
PSTRING                EQUATE          ! 14
MEMO                   EQUATE          ! 15 not used
GROUP                  EQUATE          ! 16
CLASS                  EQUATE          ! 17
QUEUE                  EQUATE(1Ah)     ! 1A
PICTURE                EQUATE(1Dh)     ! 1D not used
REFERENCE              EQUATE(1Fh)     ! 1F
FILEREF                EQUATE          ! 20
KEYREF                 EQUATE          ! 21
QUEUEREF               EQUATE          ! 22
CLASSREF               EQUATE          ! 23
WINDOWREF              EQUATE          ! 24
VIEWREF                EQUATE          ! 25
BLOBREF                EQUATE          ! 26
NAMEREF                EQUATE          ! 27
LIKE                   EQUATE          ! 28 not used
TYPE                   EQUATE          ! 29 not used
BSTRING                EQUATE          ! 2A
ASTRING                EQUATE          ! 2B
VARIANT                EQUATE(2Dh)     ! 2D not used
                     END

TYPE:EXTREF          EQUATE(80h)            ! 80 Reference field (see Type method)

!-------------------------------------------------------------------------------
! Attributes of fields
!-------------------------------------------------------------------------------
                     ITEMIZE,PRE(ATTR)
NAME                   EQUATE(01h)     ! exists external name
LABEL                  EQUATE(02h)     ! exists label
PICTURE                EQUATE(04h)     ! exists picture
OVER                   EQUATE(08h)     ! OVER-field
DIM                    EQUATE(10h)     ! Array
                     END

!-------------------------------------------------------------------------------
! Types labels of fields
!-------------------------------------------------------------------------------
                     ITEMIZE,PRE(LABEL)
ONLY                   EQUATE(-1)      ! FIELDlabel
NORMAL                 EQUATE          ! [PRE:]FIELDlabel
SUBGRP                 EQUATE          ! [PRE:][SUBGRPlabel.]FIELDlabel
FULL                   EQUATE          ! [GROUPlabel.][SUBGRPlabel.]FIELDlabel
NAME                   EQUATE          ! external field name
MIX                    EQUATE          ! LABEL:NAME or LABEL:ONLY if external name is empty
                     END

!-------------------------------------------------------------------------------
! Extended properties of fields
!-------------------------------------------------------------------------------
EXTPROP:HideInList   EQUATE(1)         ! No generate column in ListBoxFormat method
EXTPROP:RefFreeMem   EQUATE(2)         ! Automatic use DISPOSE for REF-fields

!-------------------------------------------------------------------------------
! Others constants
!-------------------------------------------------------------------------------
OUTDEBUG:ShowInText  EQUATE(-1)        ! see details in OutDebugInfo methods desc

!-------------------------------------------------------------------------------
_DynaLibEquates_     EQUATE(1)
_EndOfEquates_
!-------------------------------------------------------------------------------

  OMIT('_EndOfTBaseGroupClass_',_TBaseGroupClass_)
!-------------------------------------------------------------------------------
! TBaseGroupClass class
!-------------------------------------------------------------------------------

TBaseGroupClass      CLASS,TYPE,MODULE('dLib.clw'),DLL(0)
ShowError              BYTE
ErrCode                LONG
ListMode               BYTE
StdDeepAssign          BYTE
InitOk                 BYTE,PRIVATE
LinkMode               BYTE,PRIVATE
InGroup                BYTE,PRIVATE
LoadLikeDeclare        BYTE,PRIVATE
InLikeGroup            BYTE,PRIVATE
BindMode               BYTE,PRIVATE
Thread                 BYTE,PRIVATE
OverMode               LONG,PRIVATE
GPre                   &STRING,PRIVATE
ValidTypes             &STRING,PRIVATE
Props                  &TBaseGroupClassProps,PRIVATE
GroupStack             &TGroupStack,PRIVATE
BeginName              STRING(6),PROTECTED
FieldsQueue            &TFieldsQueue,PROTECTED
TmpRef                 GROUP
A                        ANY
D                        &DECIMAL
Dp                       &PDECIMAL
S                        &STRING
Sc                       &CSTRING
Sp                       &PSTRING
G                        &GROUP
Q                        &QUEUE
W                        &WINDOW
F                        &FILE
K                        &KEY
V                        &VIEW
B                        &BLOB
                       END

Construct              PROCEDURE,PRIVATE
Destruct               PROCEDURE,PRIVATE
SetError               PROCEDURE(LONG _ErrCode,<STRING _ErrMsg>),LONG,PROC,PROTECTED

SetValidTypes          PROCEDURE(BYTE _Reg=True),LONG,PROC
RegValidType           PROCEDURE(BYTE _Type,BYTE _Reg=True),LONG,PROC
CheckValidType         PROCEDURE(BYTE _Type),LONG,VIRTUAL

ReInit                 PROCEDURE(BYTE _SaveErrCode=False),VIRTUAL
IsInit                 PROCEDURE(BYTE _SetErr=False),LONG,PROC
IsLinkMode             PROCEDURE,LONG
IsCompleted            PROCEDURE,LONG,VIRTUAL

IsIdentical            PROCEDURE(*GROUP _Group,BYTE _CheckLabel=False),BYTE
IsIdentical            PROCEDURE(*QUEUE _Group,BYTE _CheckLabel=False),BYTE
IsIdentical            PROCEDURE(*TBaseGroupClass _Group,BYTE _CheckLabel=False),BYTE

LoadDeclare            PROCEDURE(<STRING _Declare>,<STRING _DeclareFile>,<STRING _Label>),LONG,PROC
OutDebugInfo           PROCEDURE(<STRING _DebugFile>,<STRING _CR>),STRING,PROC

LinkTo                 PROCEDURE(*GROUP _LinkGroup,<STRING _LinkPrefix>,<STRING _Label>),LONG,PROC,VIRTUAL
LinkTo                 PROCEDURE(*QUEUE _LinkQueue,<STRING _LinkPrefix>,<STRING _Label>),LONG,PROC,VIRTUAL
LinkTo                 PROCEDURE(FILE _LinkFile,<STRING _LinkPrefix>,<STRING _Label>),LONG,PROC

_Group                 PROCEDURE,LONG,PROC
_Group                 PROCEDURE(STRING _Label),LONG,PROC
_Group                 PROCEDURE(STRING _Label,STRING _Prefix),LONG,PROC,VIRTUAL
_Group                 PROCEDURE(STRING _Label,STRING _Prefix,*GROUP _TypeGroup,<STRING _TypePrefix>),LONG,PROC
_Group                 PROCEDURE(STRING _Label,STRING _Prefix,*QUEUE _TypeQueue,<STRING _TypePrefix>),LONG,PROC
_Group                 PROCEDURE(STRING _Label,STRING _Prefix,FILE _TypeFile,<STRING _TypePrefix>),LONG,PROC
_Group                 PROCEDURE(STRING _Label,STRING _Prefix,VIEW _TypeView,BYTE _MaxLevel=0),LONG,PROC
_Group                 PROCEDURE(STRING _Label,STRING _Prefix,*TBaseGroupClass _TypeGroup),LONG,PROC
_Group                 PROCEDURE(STRING _Label,STRING _Prefix,STRING _TypeGroup,BYTE _Dummy=0),LONG,PROC
_sGroup                PROCEDURE(STRING _GroupDeclare),LONG,PROC
_End                   PROCEDURE,LONG,PROC,VIRTUAL

_Thread                PROCEDURE(<BYTE _Thread>),BYTE,PROC,VIRTUAL

_Field                 PROCEDURE(STRING _Label,BYTE _Type),LONG,PROC
_Field                 PROCEDURE(STRING _Label,BYTE _Type,STRING _SizeOrPict),LONG,PROC
_Field                 PROCEDURE(STRING _Label,BYTE _Type,BYTE _Digits,BYTE _Float),LONG,PROC
_sField                PROCEDURE(STRING _FieldDeclare),LONG,PROC

_LIKE                  PROCEDURE(STRING _Label,*? _LikeVar),LONG,PROC
_LIKE                  PROCEDURE(<STRING _Label>,*TBaseGroupClass _LikeGrp,STRING _LikeField),LONG,PROC

_LIKE                  PROCEDURE(STRING _Label,STRING _Prefix,*GROUP _LikeGroup,<STRING _LikePrefix>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0),LONG,PROC
_LIKE                  PROCEDURE(STRING _Label,STRING _Prefix,*QUEUE _LikeQueue,<STRING _LikePrefix>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0),LONG,PROC
_LIKE                  PROCEDURE(STRING _Label,STRING _Prefix,FILE _LikeFile,<STRING _LikePrefix>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0),LONG,PROC
_LIKE                  PROCEDURE(STRING _Label,STRING _Prefix,VIEW _LikeView,BYTE _MaxLevel=0,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0),LONG,PROC
_LIKE                  PROCEDURE(STRING _Label,STRING _Prefix,*TBaseGroupClass _LikeGrp,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0),LONG,PROC
_LIKE                  PROCEDURE(STRING _Label,STRING _Prefix,STRING _LikeGrp,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,BYTE _Dummy=0),LONG,PROC

_REF                   PROCEDURE(STRING _Label,BYTE _BaseType=0,BYTE _RefSize=0),LONG,PROC
_ANY                   PROCEDURE(STRING _Label),LONG,PROC

_BYTE                  PROCEDURE(STRING _Label),LONG,PROC
_SHORT                 PROCEDURE(STRING _Label),LONG,PROC
_USHORT                PROCEDURE(STRING _Label),LONG,PROC
_LONG                  PROCEDURE(STRING _Label),LONG,PROC
_ULONG                 PROCEDURE(STRING _Label),LONG,PROC
_SIGNED                PROCEDURE(STRING _Label),LONG,PROC
_UNSIGNED              PROCEDURE(STRING _Label),LONG,PROC

_DATE                  PROCEDURE(STRING _Label),LONG,PROC
_TIME                  PROCEDURE(STRING _Label),LONG,PROC

_SREAL                 PROCEDURE(STRING _Label),LONG,PROC
_REAL                  PROCEDURE(STRING _Label),LONG,PROC
_BFLOAT4               PROCEDURE(STRING _Label),LONG,PROC
_BFLOAT8               PROCEDURE(STRING _Label),LONG,PROC

_DDECIMAL              PROCEDURE(STRING _Label,BYTE _Digits,BYTE _Float),LONG,PROC
_PDECIMAL              PROCEDURE(STRING _Label,BYTE _Digits,BYTE _Float),LONG,PROC

_STRING                PROCEDURE(STRING _Label,STRING _SizeOrPict,<STRING _Alignment>),LONG,PROC
_CSTRING               PROCEDURE(STRING _Label,STRING _SizeOrPict,<STRING _Alignment>),LONG,PROC
_PSTRING               PROCEDURE(STRING _Label,STRING _SizeOrPict,<STRING _Alignment>),LONG,PROC

_WINDOWREF             PROCEDURE(STRING _Label),LONG,PROC
_REPORTREF             PROCEDURE(STRING _Label),LONG,PROC

_FILEREF               PROCEDURE(STRING _Label),LONG,PROC
_KEYREF                PROCEDURE(STRING _Label),LONG,PROC
_BLOBREF               PROCEDURE(STRING _Label),LONG,PROC
_VIEWREF               PROCEDURE(STRING _Label),LONG,PROC

_QUEUEREF              PROCEDURE(STRING _Label),LONG,PROC
_CLASSREF              PROCEDURE(STRING _Label),LONG,PROC

_ASTRING               PROCEDURE(STRING _Label),LONG,PROC
_BSTRING               PROCEDURE(STRING _Label),LONG,PROC

_PICTURE               PROCEDURE(<STRING _Picture>,<STRING _Alignment>),LONG,PROC   ! _Alignment - 'L'/'C'/'R'
_NAME                  PROCEDURE(STRING _Name),LONG,PROC
_OVER                  PROCEDURE(STRING _Field),LONG,PROC
_vOVER                 PROCEDURE(<*? _OverVar>),LONG,PROC
_DIM                   PROCEDURE(USHORT _Dim1,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0),LONG,PROC
_COMMENT               PROCEDURE(STRING _Comment),LONG,PROC

ExtProps:SET           PROCEDURE(<STRING _Field>,LONG _ExtPropsMask,BYTE _Set=True),LONG,PROC,VIRTUAL
ExtProps:GET           PROCEDURE(<STRING _Field>,LONG _ExtPropsMask),LONG,PROC,VIRTUAL

Prefix                 PROCEDURE,STRING
Fields                 PROCEDURE(<STRING _Group>,BYTE _IgnoreListMode=False),LONG
FSize                  PROCEDURE(<STRING _Field>,BYTE _WithDim=True),LONG
Type                   PROCEDURE(<STRING _Field>,<*STRING _TypeName>),BYTE,PROC
Attr                   PROCEDURE(<STRING _Field>,<*STRING _AttrName>),BYTE,PROC
Label                  PROCEDURE(LONG _Field=-1,LONG _LabelType=LABEL:NORMAL),STRING
Name                   PROCEDURE(LONG _Field=-1),STRING
AnyName                PROCEDURE(LONG _Field=-1),STRING
Number                 PROCEDURE(<STRING _Field>),LONG
ListNum2Number         PROCEDURE(LONG _Field=-1),LONG
Parent                 PROCEDURE(<STRING _Field>),LONG
FOver                  PROCEDURE(<STRING _Field>,<*LONG _InOverGroup>,<*LONG _OverField>),LONG
Dims                   PROCEDURE(<STRING _Field>,<*LONG _Dim1>,<*LONG _Dim2>,<*LONG _Dim3>,<*LONG _Dim4>),LONG
BCD                    PROCEDURE(<STRING _Field>,<*LONG _Float>),LONG
Comment                PROCEDURE(<STRING _Field>),STRING,VIRTUAL
Picture                PROCEDURE(<STRING _Field>,BYTE _Default=False,<*STRING _Alignment>,<*LONG _Width>),STRING,VIRTUAL
ListBoxFormat          PROCEDURE(BYTE _NotLimitLongColumn=False,BYTE _ScrollColumn=0,BYTE _Grouping=True,BYTE _ShowOver=False,LONG _ColumnLabel=LABEL:ONLY),STRING

Buffer                 PROCEDURE,*STRING,VIRTUAL
Declares               PROCEDURE(<STRING _Field>,<*LONG _Size>),LONG,PROC,VIRTUAL

_Bind                  PROCEDURE(LONG _LabelType=LABEL:NORMAL,BYTE _StdBind=True),LONG,PROC
_UnBind                PROCEDURE

  _EndOfTBaseGroupClass_
  OMIT('_EndOfTBaseGroupClass_',_TBaseGroupClass_)

DeepAssign             PROCEDURE(*GROUP _Group,<STRING _GPrefix>,BYTE _To=False,BYTE _Prepare=False),LONG,PROC
DeepAssign             PROCEDURE(*QUEUE _Queue,<STRING _QPrefix>,BYTE _To=False,BYTE _Prepare=False),LONG,PROC
DeepAssign             PROCEDURE(FILE _File,<STRING _FPrefix>,BYTE _To=False,BYTE _Prepare=False),LONG,PROC
DeepAssign             PROCEDURE(VIEW _View,BYTE _Prepare=False),LONG,PROC
DeepAssign             PROCEDURE(*TDynaGroupClass _Class,BYTE _To=False,BYTE _Prepare=False),LONG,PROC
DeepAssign             PROCEDURE(*TDynaQueueClass _Class,BYTE _To=False,BYTE _Prepare=False),LONG,PROC
DeepAssign             PROCEDURE(*LONG _PreparedInfo,BYTE _Free=False),LONG,PROC

  _EndOfTBaseGroupClass_
  OMIT('_EndOfTBaseGroupClass_',_TBaseGroupClass_)

Addr                   PROCEDURE(<STRING _Field>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,USHORT _Dim5=0,USHORT _Dim6=0,USHORT _Dim7=0,USHORT _Dim8=0,USHORT _Dim9=0,USHORT _Dim10=0),LONG
Field                  PROCEDURE(<STRING _Field>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,USHORT _Dim5=0,USHORT _Dim6=0,USHORT _Dim7=0,USHORT _Dim8=0,USHORT _Dim9=0,USHORT _Dim10=0),*?,PROC
ClrField               PROCEDURE(<STRING _Field>,LONG _Mode=0,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,USHORT _Dim5=0,USHORT _Dim6=0,USHORT _Dim7=0,USHORT _Dim8=0,USHORT _Dim9=0,USHORT _Dim10=0),LONG,PROC
PutField               PROCEDURE(? _Value,<STRING _Field>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,USHORT _Dim5=0,USHORT _Dim6=0,USHORT _Dim7=0,USHORT _Dim8=0,USHORT _Dim9=0,USHORT _Dim10=0),LONG,PROC
FmtField               PROCEDURE(<STRING _Field>,<STRING _Format>,<STRING _Alignment>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,USHORT _Dim5=0,USHORT _Dim6=0,USHORT _Dim7=0,USHORT _Dim8=0,USHORT _Dim9=0,USHORT _Dim10=0),STRING

_New                   PROCEDURE(<STRING _Field>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,USHORT _Dim5=0,USHORT _Dim6=0,USHORT _Dim7=0,USHORT _Dim8=0,USHORT _Dim9=0,USHORT _Dim10=0,BYTE _Dummy=0),LONG,PROC
_New                   PROCEDURE(*GROUP _Group,<STRING _Field>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,USHORT _Dim5=0,USHORT _Dim6=0,USHORT _Dim7=0,USHORT _Dim8=0,USHORT _Dim9=0,USHORT _Dim10=0),LONG,PROC
_New                   PROCEDURE(*QUEUE _Queue,<STRING _Field>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,USHORT _Dim5=0,USHORT _Dim6=0,USHORT _Dim7=0,USHORT _Dim8=0,USHORT _Dim9=0,USHORT _Dim10=0),LONG,PROC
_NewStr                PROCEDURE(ULONG _Len,<STRING _Field>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,USHORT _Dim5=0,USHORT _Dim6=0,USHORT _Dim7=0,USHORT _Dim8=0,USHORT _Dim9=0,USHORT _Dim10=0),*STRING
_NewDec                PROCEDURE(BYTE _Digits,BYTE _Float,<STRING _Field>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,USHORT _Dim5=0,USHORT _Dim6=0,USHORT _Dim7=0,USHORT _Dim8=0,USHORT _Dim9=0,USHORT _Dim10=0),LONG,PROC

_Dispose               PROCEDURE(<STRING _Field>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,USHORT _Dim5=0,USHORT _Dim6=0,USHORT _Dim7=0,USHORT _Dim8=0,USHORT _Dim9=0,USHORT _Dim10=0),LONG,PROC
RefFreeMem             PROCEDURE,LONG,PROC

PutRef                 PROCEDURE(*? _Var,<STRING _Field>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,USHORT _Dim5=0,USHORT _Dim6=0,USHORT _Dim7=0,USHORT _Dim8=0,USHORT _Dim9=0,USHORT _Dim10=0),LONG,PROC
PutRef                 PROCEDURE(*GROUP _GRef,<STRING _Field>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,USHORT _Dim5=0,USHORT _Dim6=0,USHORT _Dim7=0,USHORT _Dim8=0,USHORT _Dim9=0,USHORT _Dim10=0),LONG,PROC
PutRef                 PROCEDURE(*QUEUE _QRef,<STRING _Field>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,USHORT _Dim5=0,USHORT _Dim6=0,USHORT _Dim7=0,USHORT _Dim8=0,USHORT _Dim9=0,USHORT _Dim10=0),LONG,PROC
PutRef                 PROCEDURE(*FILE _FRef,<STRING _Field>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,USHORT _Dim5=0,USHORT _Dim6=0,USHORT _Dim7=0,USHORT _Dim8=0,USHORT _Dim9=0,USHORT _Dim10=0),LONG,PROC
PutRef                 PROCEDURE(*KEY _KRef,<STRING _Field>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,USHORT _Dim5=0,USHORT _Dim6=0,USHORT _Dim7=0,USHORT _Dim8=0,USHORT _Dim9=0,USHORT _Dim10=0),LONG,PROC
PutRef                 PROCEDURE(*VIEW _VRef,<STRING _Field>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,USHORT _Dim5=0,USHORT _Dim6=0,USHORT _Dim7=0,USHORT _Dim8=0,USHORT _Dim9=0,USHORT _Dim10=0),LONG,PROC
PutRef                 PROCEDURE(*BLOB _BRef,<STRING _Field>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,USHORT _Dim5=0,USHORT _Dim6=0,USHORT _Dim7=0,USHORT _Dim8=0,USHORT _Dim9=0,USHORT _Dim10=0),LONG,PROC
PutRef                 PROCEDURE(*WINDOW _WRef,<STRING _Field>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,USHORT _Dim5=0,USHORT _Dim6=0,USHORT _Dim7=0,USHORT _Dim8=0,USHORT _Dim9=0,USHORT _Dim10=0),LONG,PROC

GetRef                 PROCEDURE(<STRING _Field>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,USHORT _Dim5=0,USHORT _Dim6=0,USHORT _Dim7=0,USHORT _Dim8=0,USHORT _Dim9=0,USHORT _Dim10=0),LONG
GetStrRef              PROCEDURE(<STRING _Field>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,USHORT _Dim5=0,USHORT _Dim6=0,USHORT _Dim7=0,USHORT _Dim8=0,USHORT _Dim9=0,USHORT _Dim10=0),*STRING

Date2Long              PROCEDURE(DATE _Date),LONG
Time2Long              PROCEDURE(TIME _Time),LONG
Long2Date              PROCEDURE(LONG _Date),DATE
Long2Time              PROCEDURE(LONG _Time),TIME

MakeBLOB               PROCEDURE(FILE _File,USHORT _BlobNo),LONG,PROC  ! Self.TmpRef.B
MakeFILE               PROCEDURE(LONG _FileRef),*FILE
MakeKEY                PROCEDURE(LONG _KeyRef),*KEY
MakeVIEW               PROCEDURE(LONG _ViewRef),*VIEW
FileRecord             PROCEDURE(FILE _File),*STRING                   ! Self.TmpRef.G

GetPrefix              PROCEDURE(*GROUP _Group),STRING
GetPrefix              PROCEDURE(*QUEUE _Queue),STRING
GetPrefix              PROCEDURE(FILE _File),STRING

SetOver                PROCEDURE(ULONG _CurrPtr,ULONG _OverPtr=0,LONG _Shift=0),LONG,PROC,PRIVATE
SetOverMode            PROCEDURE(LONG _OverAddr=0,LONG _OverSize=0),LONG,PROC,PRIVATE,VIRTUAL
GetCurrField           PROCEDURE(),LONG,PROC,PRIVATE
GetField               PROCEDURE(STRING _Field),LONG,PROC,PRIVATE
CalcFieldSize          PROCEDURE(ULONG _Field=0),LONG,PRIVATE
AddField               PROCEDURE(STRING _Label,BYTE _Type,USHORT _Size,USHORT _DefSize),LONG,PROC,PRIVATE
CheckFieldsType        PROCEDURE(),LONG,PRIVATE

SetExtData             PROCEDURE(<STRING _ExtData>),LONG,PROC,PRIVATE
GetExtData             PROCEDURE(),*STRING,PRIVATE

Offset                 PROCEDURE(<*LONG _Dims>,USHORT _Dim1=0,USHORT _Dim2=0,USHORT _Dim3=0,USHORT _Dim4=0,USHORT _Dim5=0,USHORT _Dim6=0,USHORT _Dim7=0,USHORT _Dim8=0,USHORT _Dim9=0,USHORT _Dim10=0),LONG,PRIVATE
Declare2Queue          PROCEDURE(*STRING _Declare,*STRING _Prefix,*TFieldsQueue _ResultQue),LONG,PROC,PROTECTED
DeepAssignList         PROCEDURE(*STRING _ToDeclare,*STRING _ToPrefix,*STRING _FromDeclare,*STRING _FromPrefix),*STRING,PRIVATE

LoadLikeField          PROCEDURE(*TFieldsQueue _Fields,STRING _Prefix,<STRING _Label>,BYTE _Full=True),LONG,PROC,PRIVATE
LoadTypeGroup          PROCEDURE(<*GROUP _Group>,<*QUEUE _Queue>,<STRING _Prefix>),LONG,PROC,PRIVATE
LoadFromText           PROCEDURE(<*STRING _TxtStr>,<LONG _TxtFile>,*STRING _EndLine),LONG,PROC,PROTECTED
GenerateDeclare        PROCEDURE(ULONG _FieldPtr=1,<*STRING _Declare>,BYTE _Test=False),*STRING,PROTECTED
                     END

!-------------------------------------------------------------------------------
_TBaseGroupClass_    EQUATE(1)
_EndOfTBaseGroupClass_
!-------------------------------------------------------------------------------

  OMIT('_EndOfTDynaGroupClass_',_TDynaGroupClass_)
!-------------------------------------------------------------------------------
! TDynaGroupClass class
!-------------------------------------------------------------------------------

TDynaGroupClass      CLASS(TBaseGroupClass),TYPE,MODULE('dLib.clw'),DLL(0)
G                      &GROUP

Construct              PROCEDURE,PRIVATE
Destruct               PROCEDURE,PRIVATE
ReInit                 PROCEDURE(BYTE _SaveErrCode=False),VIRTUAL
IsCompleted            PROCEDURE,LONG,VIRTUAL

LinkTo                 PROCEDURE(*GROUP _LinkGroup,<STRING _LinkPrefix>,<STRING _Label>),LONG,PROC,VIRTUAL
LinkTo                 PROCEDURE(*QUEUE _LinkQueue,<STRING _LinkPrefix>,<STRING _Label>),LONG,PROC,VIRTUAL

_Group                 PROCEDURE(STRING _Label,STRING _Prefix),LONG,PROC,VIRTUAL
_End                   PROCEDURE,LONG,PROC,VIRTUAL

_Clear                 PROCEDURE,VIRTUAL
_Thread                PROCEDURE(<BYTE _Thread>),BYTE,PROC,VIRTUAL

Buffer                 PROCEDURE,*STRING,VIRTUAL
Declares               PROCEDURE(<STRING _Field>,<*LONG _Size>),LONG,PROC,VIRTUAL

GConstruct             PROCEDURE,PRIVATE
GDestruct              PROCEDURE,PRIVATE
SetOverMode            PROCEDURE(LONG _OverAddr=0,LONG _OverSize=0),LONG,PROC,PRIVATE,VIRTUAL
                     END

!-------------------------------------------------------------------------------
_TDynaGroupClass_    EQUATE(1)
_EndOfTDynaGroupClass_
!-------------------------------------------------------------------------------

  OMIT('_EndOfTDynaQueueClass_',_TDynaQueueClass_)
!-------------------------------------------------------------------------------
! TDynaQueueClass class
!-------------------------------------------------------------------------------

TDynaQueueClass      CLASS(TBaseGroupClass),TYPE,MODULE('dLib.clw'),DLL(0)
Q                      &QUEUE
LinkG                  &GROUP,PROTECTED
Created                BYTE,PRIVATE
BySet                  BYTE,PRIVATE
OutSet                 BYTE,PRIVATE

Construct              PROCEDURE,PRIVATE
Destruct               PROCEDURE,PRIVATE
ReInit                 PROCEDURE(BYTE _SaveErrCode=False),VIRTUAL
IsCompleted            PROCEDURE,LONG,VIRTUAL

LinkTo                 PROCEDURE(*GROUP _LinkGroup,<STRING _LinkPrefix>,<STRING _Label>),LONG,PROC,VIRTUAL
LinkTo                 PROCEDURE(*QUEUE _LinkQueue,<STRING _LinkPrefix>,<STRING _Label>),LONG,PROC,VIRTUAL

_Queue                 PROCEDURE,LONG,PROC
_Queue                 PROCEDURE(STRING _Label),LONG,PROC
_Queue                 PROCEDURE(STRING _Label,STRING _Prefix),LONG,PROC,VIRTUAL
_Queue                 PROCEDURE(STRING _Label,STRING _Prefix,*GROUP _TypeGroup,<STRING _TypePrefix>),LONG,PROC
_Queue                 PROCEDURE(STRING _Label,STRING _Prefix,*QUEUE _TypeQueue,<STRING _TypePrefix>),LONG,PROC
_Queue                 PROCEDURE(STRING _Label,STRING _Prefix,FILE _TypeFile,<STRING _TypePrefix>),LONG,PROC
_Queue                 PROCEDURE(STRING _Label,STRING _Prefix,VIEW _TypeView,BYTE _MaxLevel=0),LONG,PROC
_Queue                 PROCEDURE(STRING _Label,STRING _Prefix,*TBaseGroupClass _TypeGroup),LONG,PROC
_Queue                 PROCEDURE(STRING _Label,STRING _Prefix,STRING _TypeGroup,BYTE _Dummy=0),LONG,PROC
_sQueue                PROCEDURE(STRING _QueueDeclare),LONG,PROC
_Group                 PROCEDURE(STRING _Label,STRING _Prefix),LONG,PROC,VIRTUAL
_End                   PROCEDURE,LONG,PROC,VIRTUAL

_Clear                 PROCEDURE,VIRTUAL
_Thread                PROCEDURE(<BYTE _Thread>),BYTE,PROC,VIRTUAL

Buffer                 PROCEDURE,*STRING,VIRTUAL
Declares               PROCEDURE(<STRING _Field>,<*LONG _Size>),LONG,PROC,VIRTUAL

_Sort                  PROCEDURE(STRING _F1,<STRING _F2>,<STRING _F3>,<STRING _F4>,<STRING _F5>,<STRING _F6>,<STRING _F7>,<STRING _F8>,<STRING _F9>,<STRING _F10>),LONG,PROC
nAdd                   PROCEDURE(LONG _F1=0,LONG _F2=0,LONG _F3=0,LONG _F4=0,LONG _F5=0,LONG _F6=0,LONG _F7=0,LONG _F8=0,LONG _F9=0,LONG _F10=0),LONG,PROC
sAdd                   PROCEDURE(STRING _Fields),LONG,PROC
_Add                   PROCEDURE(<STRING _F1>,<STRING _F2>,<STRING _F3>,<STRING _F4>,<STRING _F5>,<STRING _F6>,<STRING _F7>,<STRING _F8>,<STRING _F9>,<STRING _F10>),LONG,PROC
_Put                   PROCEDURE(<STRING _F1>,<STRING _F2>,<STRING _F3>,<STRING _F4>,<STRING _F5>,<STRING _F6>,<STRING _F7>,<STRING _F8>,<STRING _F9>,<STRING _F10>),LONG,PROC
_Get                   PROCEDURE(<STRING _F1>,<STRING _F2>,<STRING _F3>,<STRING _F4>,<STRING _F5>,<STRING _F6>,<STRING _F7>,<STRING _F8>,<STRING _F9>,<STRING _F10>),LONG,PROC

_Set                   PROCEDURE(<STRING _F1>,<STRING _F2>,<STRING _F3>,<STRING _F4>,<STRING _F5>,<STRING _F6>,<STRING _F7>,<STRING _F8>,<STRING _F9>,<STRING _F10>),LONG,PROC
_Next                  PROCEDURE,LONG,PROC
_Prev                  PROCEDURE,LONG,PROC

_Free                  PROCEDURE,LONG,PROC

ParseParams            PROCEDURE(*STRING _ParamsList,*LONG[] _Params),LONG,PROTECTED
GetNumField            PROCEDURE(*STRING _Field),LONG,PROTECTED
QConstruct             PROCEDURE,PRIVATE
QDestruct              PROCEDURE,PRIVATE
SetOverMode            PROCEDURE(LONG _OverAddr=0,LONG _OverSize=0),LONG,PROC,PRIVATE,VIRTUAL
                     END

!-------------------------------------------------------------------------------
_TDynaQueueClass_    EQUATE(1)
_EndOfTDynaQueueClass_
!-------------------------------------------------------------------------------

!-------------------------------------------------------------------------------
! Global procedures
!-------------------------------------------------------------------------------

                     MAP
                       MODULE('dLib')
                         DynaLib::SetMsgLang(<STRING _LangCode>),STRING,PROC,DLL(0)
                         DynaLib::SetDefaultFormats(<STRING _DateFormat>,<STRING _TimeFormat>,<STRING _RealFormat>),STRING,PROC,DLL(0)

                         dGroupType::Find(STRING _dGroup),*TBaseGroupClass,DLL(0)
                         dGroup::Find(STRING _dGroup),*TDynaGroupClass,DLL(0)
                         dQueue::Find(STRING _dQueue),*TDynaQueueClass,DLL(0)
                       END
                     END

!-------------------------------------------------------------------------------
!-------------------------------------------------------------------------------
